/// <reference types="node" />
import { Discovery } from '../../discovery';
import { AuthService, ResolvedUser } from './authservice';
export declare const UsernamePasswordConstants: {
    saltWorkIterations: number;
    keyLength: number;
    saltLength: number;
    digest: string;
};
export declare class UsernamePasswordAuthService extends AuthService {
    private passwordRealm;
    start(discovery: Discovery): Promise<void>;
    hashPassword(clearTextPassword: string, salt: Buffer): Promise<Buffer>;
    createSalt(saltWorkFactor: number): Promise<Buffer>;
    comparePassword(candidatePassword: string, salt: Buffer, hash: Buffer): Promise<boolean>;
    private attemptToRegister(username, password, isAdmin?);
    private attemptToLogin(username, password);
    authenticateOrCreateUser(body: any): Promise<ResolvedUser>;
}
